"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("mocha");
const sinon_1 = __importDefault(require("sinon"));
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const ada = __importStar(require("./index"));
const chai_1 = require("chai");
(0, mocha_1.describe)('Running Tests', function () {
    this.slow(0);
    let jwt_stub;
    let end_stub;
    const test_resp = {
        foo: 'bar',
    };
    before(() => {
        jwt_stub = sinon_1.default.stub(jsonwebtoken_1.default, 'verify')
            .callsFake(() => {
            return test_resp;
        });
        end_stub = sinon_1.default.stub(ada, 'validateFromEndpoint')
            .resolves(test_resp);
    });
    after(() => {
        jwt_stub.restore();
        end_stub.restore();
    });
    it('should validate user local approach', async () => {
        const data = await ada.validate({
            fetchuser: false,
            token: 'Bearer xyz',
        });
        chai_1.assert.equal(data, test_resp);
    });
    it('should validate user endpoint approach', async () => {
        const data = await ada.validate({
            fetchuser: true,
            token: 'Bearer xyz',
            app_id: 'test_app',
        });
        chai_1.assert.equal(data, test_resp);
    });
});
